%define STD_INPUT_HANDLE   -10
%define STD_OUTPUT_HANDLE  -11
%define STD_ERROR_HANDLE   -12

%define FILE_BEGIN           0
%define FILE_CURRENT         1
%define FILE_END             2

GLOBAL EXPORTS
section '.exprt' align 16
;**********************************************************************************
EXPORTS: ;/////////////////////////////////////////////////////////////////////////
;**********************************************************************************
dd sz_ExitProcess,              ExitProcess
dd sz_GetStdHandle,             GetStdHandle
dd sz_SetConsoleMode,           SetConsoleMode
dd sz_WriteFile,                WriteFile
dd sz_ReadFile,                 ReadFile
dd sz_GetCommandLineA,          GetCommandLineA
dd sz_GlobalAlloc,              GlobalAlloc
dd sz_GlobalFree,               GlobalFree
dd sz_GlobalReAlloc,            GlobalReAlloc
dd sz_Sleep,                    Sleep
dd sz_FlushConsoleInputBuffer,  FlushConsoleInputBuffer
dd sz_CloseHandle,              CloseHandle
dd sz_GetFileSize,              GetFileSize
dd sz_CreateFileA,              CreateFileA
dd sz_SetFilePointer,           SetFilePointer
dd sz_VirtualAlloc,             VirtualAlloc
dd sz_VirtualFree,              VirtualFree
dd sz_SetConsoleCursorPosition, SetConsoleCursorPosition
dd sz_DeleteFileA,              DeleteFileA
dd sz_FindClose,                FindClose
dd sz_FindFirstFileA,           FindFirstFileA
dd 0
sz_ExitProcess              db "ExitProcess",0
sz_GetStdHandle             db "GetStdHandle",0
sz_SetConsoleMode           db "SetConsoleMode",0
sz_WriteFile                db "WriteFile",0
sz_ReadFile                 db "ReadFile",0
sz_GetCommandLineA          db "GetCommandLineA",0
sz_GlobalAlloc              db "GlobalAlloc",0
sz_GlobalFree               db "GlobalFree",0
sz_GlobalReAlloc            db "GlobalReAlloc",0
sz_Sleep                    db "Sleep",0
sz_FlushConsoleInputBuffer  db "FlushConsoleInputBuffer",0
sz_CloseHandle              db "CloseHandle",0
sz_GetFileSize              db "GetFileSize",0
sz_CreateFileA              db "CreateFileA",0
sz_SetFilePointer           db "SetFilePointer",0
sz_VirtualAlloc             db "VirtualAlloc",0
sz_VirtualFree              db "VirtualFree",0
sz_SetConsoleCursorPosition db "SetConsoleCursorPosition",0
sz_DeleteFileA              db "DeleteFileA",0
sz_FindClose                db "FindClose",0
sz_FindFirstFileA           db "FindFirstFileA",0

section '.code' align 16
align 16
;**********************************************************************************
ExitProcess: ;/////////////////////////////////////////////////////////////////////
;**********************************************************************************
        xor    eax, eax
        dec    eax
        int    64
        ; ret not need
align 16			
;**********************************************************************************
GetStdHandle: ;////////////////////////////////////////////////////////////////////
;**********************************************************************************
        push   ebx
        push   esi
        push   edi
; if already loaded then do nothing
        cmp    [console], dword 0
        jne    .do_nothing

        push   sz_console
        call   load.library
        mov    [console], eax
        mov    ecx, eax
        mov    ebx, getprocaddress
        push   ecx
        push   sz_con_init
        call   ebx
        mov    [con_init], eax
        push   ecx
        push   sz_con_write_asciiz
        call   ebx
        mov    [con_write_asciiz], eax
        push   ecx
        push   sz_con_exit
        call   ebx
        mov    [con_exit], eax
        push   ecx
        push   sz_con_gets
        call   ebx
        mov    [con_gets], eax
        push   ecx
        push   sz_con_write_string
        call   ebx
        mov    [con_write_string], eax
        push   ecx
        push   sz_con_set_flags
        call   ebx
        mov    [con_set_flags], eax	
        push   ecx
        push   sz_con_set_cursor_pos
        call   ebx
        mov    [con_set_cursor_pos], eax
        push   ecx
        push   sz_con_printf
        call   ebx
        mov    [con_printf], eax
        push   con_caption
        push   -1
        push   -1
        push   -1
        push   -1
        call   [con_init]
.do_nothing:

        mov    eax, con_handle ; return pointer to console descriptor

        pop    edi
        pop    esi
        pop    ebx
        ret    4
align 16				
;**********************************************************************************
WriteFile: ;///////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hFile                  [ebp +  8] ; handle to the file
%define lpBuffer               [ebp + 12] ; pointer to buffer containing data
%define nNumberOfBytesToWrite  [ebp + 16] ; number of bytes to be written
%define lpNumberOfBytesWritten [ebp + 20] ; pointer to variable that receives number of bytes written
%define lpOverlapped           [ebp + 24] ; pointer to OVERLAPPED structure
				push   ebp
				mov    ebp, esp
        push   ebx
        push   esi
        push   edi
;---------
        mov    eax, hFile
        cmp    [eax + 8], dword "CON"
        je     .CON
        lea    edx, [eax + 8]
        push   edx ;filepath
        dec    esp
        mov    [esp], byte 0
        push   dword lpBuffer ;buffer
        push   dword nNumberOfBytesToWrite;count
        push   dword 0
        push   dword [eax + 4];position ;  in InternalFileInfo in libio
        push   dword 2
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25 ; restore stack
        mov    edx, lpNumberOfBytesWritten
        mov    [edx], ebx
				mov    edx, hFile
				add    [edx + 4], ebx
        jmp    .exit
.CON:

        ; push    dword lpBuffer
        ; call    [con_printf]
        ; add     esp, 4

        push   dword nNumberOfBytesToWrite
        push   dword lpBuffer
        call   [con_write_string]

        ; push   dword lpBuffer
        ; call   [con_write_asciiz]

.exit:
;---------
        pop    edi
        pop    esi
        pop    ebx
				pop    ebp
        ret    20
%undef hFile
%undef lpBuffer
%undef nNumberOfBytesToWrite
%undef lpNumberOfBytesWritten
%undef lpOverlapped
align 16
;**********************************************************************************
ReadFile: ;////////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hFile                  [ebp +  8] ; handle to the file
%define lpBuffer               [ebp + 12] ; pointer to buffer that receives data
%define nNumberOfBytesToRead   [ebp + 16] ; maximum number of bytes to read
%define lpNumberOfBytesRead    [ebp + 20] ; pointer to variable that receives number of bytes read
%define lpOverlapped           [ebp + 24] ; pointer to OVERLAPPED structure
				push   ebp
				mov    ebp, esp
        push   ebx
        push   esi
        push   edi
;---------
        mov    eax, hFile
        cmp    [eax + 8], dword "CON"
        je     .CON
        lea    edx, [eax + 8]
        push   edx ;filepath
        dec    esp
        mov    [esp], byte 0
        push   dword lpBuffer ;buffer
        push   dword nNumberOfBytesToRead;count
        push   dword 0
        push   dword [eax + 4];position ;  in InternalFileInfo in libio
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25 ; restore stack
        mov    edx, lpNumberOfBytesRead
        mov    [edx], ebx
				mov    edx, hFile
				add    [edx + 4], ebx
        jmp    .exit
.CON:
        push   dword nNumberOfBytesToRead
        push   dword lpBuffer
        call   [con_gets]
.exit:
;---------
        pop    edi
        pop    esi
        pop    ebx
        pop    ebp				
        ret    20
%undef hFile
%undef lpBuffer
%undef nNumberOfBytesToRead
%undef lpNumberOfBytesRead
%undef lpOverlapped
align 16
;**********************************************************************************
SetConsoleMode: ;//////////////////////////////////////////////////////////////////
;**********************************************************************************
; ignore input parameters
        xor    eax, eax
				dec    eax
        ret    8
align 16				
;**********************************************************************************
GetCommandLineA: ;/////////////////////////////////////////////////////////////////
;**********************************************************************************
        push   edi
				mov    edi, [28]
				xor    al, al
				xor    ecx, ecx
				dec    ecx
				repne scasb
				mov    eax, edi
				pop    edi
        ret
align 16				
;**********************************************************************************
GlobalAlloc: ;/////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define uFlags                [esp +  4 +1*4] ; memory allocation attributes
%define dwBytes               [esp +  8 +1*4] ; number of bytes to allocate
        push   ebx
; uFlags ignored
        mov    eax, 68
        mov    ebx, 12
        mov    ecx, dwBytes
        int    64

        pop    ebx
        ret    8
%undef uFlags
%undef dwBytes
align 16
;**********************************************************************************
GlobalFree: ;//////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hMem                  [esp +  4 +1*4] ; handle to global memory object
        push   ebx

        mov    eax, 68
        mov    ebx, 13
        mov    ecx, hMem
        int    64

        pop    ebx
        ret    4
%undef hMem
align 16
;**********************************************************************************
GlobalReAlloc: ;///////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hMem                  [esp +  4 +1*4] ; handle to global memory object
%define dwBytes               [esp +  8 +1*4] ; new size of memory block in bytes
%define uFlags                [esp + 12 +1*4] ; reallocation options
        push   ebx
; uFlags ignored
        mov    eax, 68
        mov    ebx, 20
        mov    ecx, dwBytes
        mov    edx, hMem
        int    64

        pop    ebx
        ret    12
%undef hMem
%undef dwBytes
%undef uFlags
align 16
;**********************************************************************************
Sleep: ;///////////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define dwMilliseconds        [esp +  4 +1*4] ; time interval
        push   ebx

        mov    eax, dwMilliseconds
        mov    ebx, 10
        xor    edx, edx
        div    ebx
        mov    ebx, eax

        mov    eax, 5
        int    64

        pop    ebx
        ret    4
%undef dwMilliseconds
align 16
;**********************************************************************************
FlushConsoleInputBuffer: ;/////////////////////////////////////////////////////////
;**********************************************************************************
; not implemented correctly
        xor    eax, eax
        dec    eax
        ret    4
align 16				
;**********************************************************************************
CloseHandle: ;/////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hObject               [esp +  4 +1*4]
; not implemented correctly
        xor    eax, eax
        dec    eax
        ret    4
%undef hObject
align 16
;**********************************************************************************
GetFileSize: ;/////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hFile                 [esp +  4 +1*4]
%define lpFileSizeHigh        [esp +  8 +1*4]
        push   ebx
; lpFileSizeHigh ignored
        mov    [esp - (25 + 40) + 0], dword 5
        mov    [esp - (25 + 40) + 8], dword 0
        mov    [esp - (25 + 40) + 20], byte 0
        lea    eax, [esp - 40]
        mov    [esp - (25 + 40) + 16], eax
        lea    ebx, [esp - (25 + 40)]
        mov    eax, hFile
        mov    eax, [eax + 8] ; as in InternalFileInfo in libio
        mov    [esp - (25 + 40) + 21], eax
        mov    eax, 70
        int    64
        test   eax, eax
        jz     .no_error
        ; mov    eax, INVALID_FILE_SIZE
        xor    eax, eax
        dec    eax
        jmp    .exit
.no_error:
        mov    eax, [esp - (25 + 40) + 25 + 32] ; file.size
.exit:
        pop    ebx
        ret    8
%undef hFile
%undef lpFileSizeHigh
align 16
;**********************************************************************************
CreateFileA: ;//////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define lpFileName            [esp +  4 +3*4]
%define dwDesiredAccess       [esp +  8 +3*4]
%define dwShareMode           [esp + 12 +3*4]
%define lpSecurityAttributes  [esp + 16 +3*4]
%define dwCreationDisposition [esp + 20 +3*4]
%define dwFlagsAndAttributes  [esp + 24 +3*4]
%define hTemplateFile         [esp + 28 +3*4]
        push   ebx
        push   esi
        push   edi
;---------
        mov    eax, 68
        mov    ebx, 12
        mov    ecx, 4096
        int    64

        mov    edx, eax

        lea     edi, [eax + 8] ; as in InternalFileInfo in libio
        mov     esi, lpFileName
.copy_name:
        lodsb
        stosb
        test   al, al
        jnz    .copy_name

        mov    eax, edx ; return pointer to file descriptor
;---------
        pop    edi
        pop    esi
        pop    ebx
        ret    28
%undef lpFileName
%undef dwDesiredAccess
%undef dwShareMode
%undef lpSecurityAttributes
%undef dwCreationDisposition
%undef dwFlagsAndAttributes
%undef hTemplateFile
align 16
;**********************************************************************************
SetFilePointer: ;//////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hFile                 [esp +  4 +3*4]
%define lDistanceToMove       [esp +  8 +3*4]
%define lpDistanceToMoveHigh  [esp + 12 +3*4]
%define dwMoveMethod          [esp + 16 +3*4]
        push   ebx
        push   esi
        push   edi
;---------
        mov    eax, hFile
				cmp    dwMoveMethod, dword FILE_BEGIN
				je     .FILE_BEGIN
				cmp    dwMoveMethod, dword FILE_CURRENT
				je     .FILE_CURRENT
				jmp    .FILE_END
.FILE_BEGIN:
				mov    edx, lDistanceToMove
				mov    [eax + 4], edx
				jmp    .exit
.FILE_CURRENT:
				mov    edx, lDistanceToMove
				add    [eax + 4], edx
				jmp    .exit
.FILE_END:
				mov    edx, lDistanceToMove
				add    [eax + 4], edx
.exit:
        mov    eax, [eax + 4]
;---------
        pop    edi
        pop    esi
        pop    ebx
        ret    16
%undef hFile
%undef lDistanceToMove
%undef lpDistanceToMoveHigh
%undef dwMoveMethod
align 16				
;**********************************************************************************
VirtualAlloc: ;////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define lpAddress             [esp +  4 +1*4]
%define dwSize                [esp +  8 +1*4]
%define flAllocationType      [esp + 12 +1*4]
%define flProtect             [esp + 16 +1*4]
        push   ebx

        mov    eax, 68
        mov    ebx, 12
        mov    ecx, dwSize
        int    64

        pop    ebx
        ret    16
%undef lpAddress
%undef dwSize
%undef flAllocationType
%undef flProtect
align 16
;**********************************************************************************
VirtualFree: ;/////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define lpAddress             [esp +  4 +1*4]
%define dwSize                [esp +  8 +1*4]
%define dwFreeType            [esp + 12 +1*4]
        push   ebx

        mov    eax, 68
        mov    ebx, 13
        mov    ecx, lpAddress
        int    64

        pop    ebx
        ret    12
%undef lpAddress
%undef dwSize
%undef dwFreeType
align 16
;**********************************************************************************
SetConsoleCursorPosition: ;////////////////////////////////////////////////////////
;**********************************************************************************
%define hConsoleOutput        [esp +  4 +3*4]
%define dwCursorPosition      [esp +  8 +3*4]
        push   ebx
        push   esi
        push   edi
        
				mov    edx, dwCursorPosition
				shld   eax, edx, 16
				shr    edx, 16
				
				push   eax
				push   edx
        call   [con_set_cursor_pos]

        pop    edi
        pop    esi
        pop    ebx
        ret    8
%undef hConsoleOutput
%undef dwCursorPosition
align 16
;**********************************************************************************
DeleteFileA: ;/////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define lpFileName            [esp +  4 +1*4] ; name of file 
        push   ebx
				
        mov    [esp - (25 + 40) + 0], dword 8
        mov    [esp - (25 + 40) + 8], dword 0
        mov    [esp - (25 + 40) + 20], byte 0
        lea    eax, [esp - 40]
        mov    [esp - (25 + 40) + 16], eax
        lea    ebx, [esp - (25 + 40)]
        mov    eax, lpFileName
        mov    [esp - (25 + 40) + 21], eax
        mov    eax, 70
        int    64
				
				pop    ebx
        ret    4
%undef lpFileName
align 16				
;**********************************************************************************
FindClose: ;///////////////////////////////////////////////////////////////////////
;**********************************************************************************
%define hFindFile             [esp +  4 +1*4] ; file search handle

        ret    4
%undef hFindFile
align 16
;**********************************************************************************
FindFirstFileA: ;//////////////////////////////////////////////////////////////////
;**********************************************************************************
%define lpFileName            [esp +  4 +3*4] ; name of file 
%define lpFindFileData        [esp +  8 +3*4] ; pointer to WIN32_FIND_DATA structure
        push   ebx
        push   esi
        push   edi

        pop    edi
        pop    esi
        pop    ebx
        ret    8
%undef lpFileName
%undef lpFindFileData




; ------------------------------------------------------------- ;
load.library:
        mov    eax, 68
        mov    ebx, 19
        mov    ecx, [esp + 4]
        int    64
        ret    4
; ------------------------------------------------------------- ;
getprocaddress:
        mov    edx, [esp + 8]
        xor    eax, eax
        test   edx, edx
        jz     .end
.next:
        xor    eax, eax
        cmp    [edx], dword 0
        jz     .end
        mov    esi, [edx]
        mov    edi, [esp + 4]
.next_:
        lodsb
        scasb
        jne    .fail
        or     al, al
        jnz    .next_
        jmp    .ok
.fail:
        add    edx, 8
        jmp    .next
.ok:
        mov    eax, [edx + 4]
.end:
        ret    8
; ------------------------------------------------------------- ;





section '.data' align 16

con_caption           db "",0
con_init              dd 0
con_write_asciiz      dd 0
con_exit              dd 0
con_gets              dd 0
con_write_string      dd 0
con_set_flags         dd 0
con_set_cursor_pos    dd 0
con_printf            dd 0
console               dd 0
sz_con_init           db "con_init",0
sz_con_write_asciiz   db "con_write_asciiz",0
sz_con_exit           db "con_exit",0
sz_con_gets           db "con_gets",0
sz_con_write_string   db "con_write_string",0
sz_console            db "/sys/lib/console.obj",0
sz_con_set_flags      db "con_set_flags",0
sz_con_set_cursor_pos db "con_set_cursor_pos",0
sz_con_printf         db "con_printf",0

con_handle:
dd 0
dd 0
dd "CON"


